/**
 * Created by anthony on 10/09/2016.
 */
var gulp = require('gulp');
var _ = require('lodash');
var fs = require('fs');
var path = require('path');
var del = require('del');
var rename = require('gulp-rename');
var runSequence = require('run-sequence');

function getPlatformPaths(srcpath) {
    return fs.readdirSync(srcpath).filter(function(file) {
        return fs.statSync(path.join(srcpath, file)).isDirectory();
    });
}

var platforms = getPlatformPaths(__dirname + '/platforms');

_.each(platforms, function (platformName) {
    var platformPath = __dirname + '/platforms/' + platformName;
    fs.readdirSync(platformPath).forEach(function (task) {
        if (task === 'gulpfile.js'){
            console.log('path:', path.join(platformPath, task));
            require(path.join(platformPath, task));
        }
    });

});

var platformTasks = _.filter(_.keys(gulp.tasks), function (o) {
    return _.startsWith(o, 'platform:');
});

gulp.task('platforms', platformTasks);

gulp.task('build-clean', function() {
    return del(['./build']);
});

gulp.task('copy-app-config', function() {
    var appConfigPath = './example/app_definition.json';
    return gulp.src(appConfigPath)
        .pipe(rename('app_config.json'))
        .pipe(gulp.dest('./build'))
});

gulp.task('build', function(cb) {
    runSequence('build-clean', 'copy-app-config', 'platform:android', cb);
});